
from DateTime import DateTime

REQUEST=context.REQUEST
context_obj = REQUEST.get('context_obj', context)
context_url = context_obj.absolute_url()
portal_calendar = context.portal_calendar
portal_url = context.portal_url()

current = DateTime()
current_day = current.day()
current_month = current.month()
current_year = current.year()
month = REQUEST.get('month', current_month)
year = REQUEST.get('year', current_year)
current_month_and_year = (current_year == year and current_month == month)

weeks = portal_calendar.getCPSEventsForCalendar(month=month, 
                                                year=year, 
                                                location=None, 
                                                event_types=[])

url0 = REQUEST.get('URL0', context)
prevMonthTime = portal_calendar.getPreviousMonth(month, year)
nextMonthTime = portal_calendar.getNextMonth(month, year)
url_string =  '%s?month:int=%d&year:int=%d' 
link_prevmonth = url_string % (url0, prevMonthTime.month(), prevMonthTime.year())
link_nextmonth = url_string % (url0, nextMonthTime.month(), nextMonthTime.year())
this_month = DateTime(('%s/1/%s') %(month, year)).strftime('%B').capitalize()

calendar = []
previews = []
for week in weeks:
    weekdays = []
    for day in week:
        weekday = {}
        daynumber = day['day'] 
        event = day['event']

        weekday['daynumber'] = daynumber
        weekday['event'] = event
        if current_month_and_year and current_day == int(daynumber):
            dayclass = test(event, "todayevent", "todaynoevent")
        else:
            dayclass = test(event, "event", "")
        weekday['class'] = dayclass

        if event:
            datestring = '%s/%s/%s' % (year, month, daynumber)
            date_id = '%s%s%s' % (year, month, daynumber)
            info = {'date': datestring, 'date_id': 'day%s' % date_id, 'eventslist': day['eventslist'] }
            previews.append(info)
                 
            weekday['date_id'] = date_id
            weekday['link'] = context.getCalCPSDayViewParams(context_url=context_url,  \
                                              datestring=datestring, \
                                              location=None, event_types=[])
    
        weekdays.append(weekday)
    calendar.append(weekdays) 

return {'calendar': calendar, 
        'previews': previews,
        'link_prevmonth': link_prevmonth,
        'link_nextmonth': link_nextmonth,
        'this_month': this_month,
        'this_year': year,
       }
